#ifndef BENUTZERHELPER_H
#define BENUTZERHELPER_H

#include "Benutzer.h"
#include "DatabaseContext.h"

class BenutzerHelper {

public:
	static void aktualisiereDBBenutzer(DatabaseContext *context, Benutzer *benutzer, bool onlyPassword);
	static void aktualisiereDBBenutzerBerechtigungen(DatabaseContext *context, Benutzer *benutzer);
	static void deleteBenutzer(DatabaseContext *context, Benutzer *benutzer);


private:
	static QString getDBBenutzerName(DatabaseContext *context, Benutzer *benutzer);

	static void setPrivileges(DatabaseContext *context, Benutzer *benutzer);
	static void setPrivilegesForNothingUser(DatabaseContext *context, Benutzer *benutzer);
	static void setPrivilegesForWebOnlyUser(DatabaseContext *context, Benutzer *benutzer);
	static void setPrivilegesForStandardUser(DatabaseContext *context, Benutzer *benutzer);
	static void setPrivilegesForAdmin(DatabaseContext *context, Benutzer *benutzer);
	static void revokeAllPrivileges(DatabaseContext *context, Benutzer *benutzer);
	static void grantFullTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
	static void grantReadOnlyTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
	static void grantInsertOnlyTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
	static void grantInsertUpdateTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
	static void grantReadInsertTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
	static void revokeAll(DatabaseContext *context, Benutzer *benutzer);
	static void revokeTableAccess(DatabaseContext *context, Benutzer *benutzer, QString entityDBName);
};
#endif
