#include "AttributeData.h"

AttributeData::AttributeData() {
	this->foreignKeyToDB = QVariant();
	this->foreignKeyToDataTuple = NULL;
	this->value = QVariant();

	this->setNull();
}

AttributeData::AttributeData(AttributeData *attributeData) {
	if (attributeData->isForeignKeyToDB()) {
		setForeignKeyToDB(attributeData->getForeignKeyToDB());
	} else if (attributeData->isValue()) {
		setValue(attributeData->getValue());
	} else if (attributeData->isForeignKeyToDataTuple()) {
		setForeignKeyToDataTuple(attributeData->getForeignKeyToDataTuple());
	} else if (attributeData->isNull()) {
		setNull();
	}
}

AttributeData::AttributeData(QVariant value) {
	setValue(value);
}

void AttributeData::setForeignKeyToDB(QVariant foreignKeyToDB) {
	this->foreignKeyToDB = foreignKeyToDB;
	this->foreignKeyToDataTuple = NULL;
	this->value = QVariant();

	this->isAForeignKeyToDB = true;
	this->isAForeignKeyToDataTuple = false;
	this->isAValue = false;
	this->isANullValue = false;
}

void AttributeData::setForeignKeyToDataTuple(DataTuple *foreignKeyToDataTuple) {
	this->foreignKeyToDB = QVariant();
	this->foreignKeyToDataTuple = foreignKeyToDataTuple;
	this->value = QVariant();

	this->isAForeignKeyToDB = false;
	this->isAForeignKeyToDataTuple = true;
	this->isAValue = false;
	this->isANullValue = false;
}

void AttributeData::setValue(QVariant value) {
	this->foreignKeyToDB = QVariant();
	this->foreignKeyToDataTuple = NULL;
	this->value = value;

	this->isAForeignKeyToDB = false;
	this->isAForeignKeyToDataTuple = false;
	this->isAValue = true;
	this->isANullValue = false;
}

void AttributeData::setNull() {
	this->foreignKeyToDB = QVariant();
	this->foreignKeyToDataTuple = NULL;
	this->value = QVariant();

	this->isAForeignKeyToDB = false;
	this->isAForeignKeyToDataTuple = false;
	this->isAValue = false;
	this->isANullValue = true;
}

bool AttributeData::isForeignKeyToDB() {
	return isAForeignKeyToDB;
}

bool AttributeData::isForeignKeyToDataTuple() {
	return isAForeignKeyToDataTuple;
}

bool AttributeData::isValue() {
	return isAValue;
}

bool AttributeData::isNull() {
	return isANullValue;
}

QVariant AttributeData::getForeignKeyToDB() {
	return foreignKeyToDB;
}

DataTuple *AttributeData::getForeignKeyToDataTuple() {
	return foreignKeyToDataTuple;
}

QVariant AttributeData::getValue() {
	return value;
}
/*
bool AttributeData::isInvalid() {
	return (!isForeignKeyToDB() && !isForeignKeyToDataTuple() && !isValue())
	   || (isValue() && !getValue().isValid());
}
*/
