#include "ForeignKeyEdge.h"

ForeignKeyEdge::ForeignKeyEdge(ForeignKeyNode *inNode, const Attribute *attribute, ForeignKeyNode *outNode,
							   QString pathKey) {
	this->inNode = inNode;
	this->attribute = attribute;
	this->outNode = outNode;
	this->pathKey = pathKey;
}

QString ForeignKeyEdge::getAttributeDBName() {
	return attribute->getDBName();
}

ForeignKeyNode *ForeignKeyEdge::getInNode() {
	return inNode;
}

ForeignKeyNode *ForeignKeyEdge::getOutNode() {
	return outNode;
}

QString ForeignKeyEdge::getOutNodeEntityDBName() {
	return outNode->getEntity()->getDBName();
}

QString ForeignKeyEdge::getPathKey() {
	return pathKey;
}
