#ifndef FOREIGNKEYGRAPH_H
#define FOREIGNKEYGRAPH_H

#include <QString>
#include <QStringList>

#include <map>
#include <vector>

#include "Attribute.h"
#include "DatabaseContext.h"
#include "ForeignKeyEdge.h"
#include "ForeignKeyNode.h"

class ForeignKeyGraph {

public:
	ForeignKeyGraph(const Entity *entity);
	ForeignKeyGraph(const Attribute *attribute);
	~ForeignKeyGraph();

	ForeignKeyNode *getRootNode();

	/** Returns wether there is a node for the given entity.
	 *  The root node does not count as node with respect to this function.
	 */
	bool hasNodeForEntity(QString entityDBName);
//	ForeignKeyNode *getNodeForEntity(QString entityDBName);

	void addNodeToGraph(ForeignKeyNode *node);

	std::vector<QStringList> getAttributePaths();

	void printStructure(DatabaseContext *context);

private:
	ForeignKeyNode *rootNode;
	std::map<QString, ForeignKeyNode*> entityDBNameToNode;


};
#endif
