#include "ImportException.h"

#include <iostream>

ImportException::ImportException(QString shortText, QString longText) : Exception(shortText, longText) {
	std::cout << "constructor called." << std::endl;
	this->hasALineNumber = false;
}

ImportException::ImportException(QString shortText, QString longText, int lineNumber) : Exception(shortText, longText) {
	setLineNumber(lineNumber);
}

ImportException::ImportException(QString eventLogCategory, QString eventLogLocation, QString shortText, QString longText) 
	: Exception(eventLogCategory, eventLogLocation, shortText, longText) {
}

ImportException::ImportException(QString eventLogCategory, QString eventLogLocation, QString shortText, QString longText, int lineNumber) 
	: Exception(eventLogCategory, eventLogLocation, shortText, longText) {
	setLineNumber(lineNumber);
}

ImportException::ImportException(QString eventLogCategory, QString eventLogLocation, int eventLogLevel, QString shortText, QString longText, int lineNumber)
	: Exception(eventLogCategory, eventLogLocation, eventLogLevel, shortText, longText) {
	setLineNumber(lineNumber);
}

void ImportException::setLineNumber(int lineNumber) {
	this->lineNumber = lineNumber;
	this->hasALineNumber = true;
}

int ImportException::getLineNumber() {
	return lineNumber;
}

bool ImportException::hasLineNumber() {
	return hasALineNumber;
}
