#ifndef IMPORTEXCEPTION_H
#define IMPORTEXCEPTION_H

#include <QString>

#include "Exception.h"

class ImportException : public Exception {

public:
	ImportException(QString shortText, QString longText);
	ImportException(QString shortText, QString longText, int lineNumber);
	ImportException(QString eventLogCategory, QString eventLogLocation, QString shortText, QString longText);
	ImportException(QString eventLogCategory, QString eventLogLocation, QString shortText, QString longText, int lineNumber);
	ImportException(QString eventLogCategory, QString eventLogLocation, int eventLogLevel, QString shortText, QString longText, int lineNumber);

	virtual void setLineNumber(int lineNumber);
	virtual int getLineNumber();
	virtual bool hasLineNumber();

private:
	bool hasALineNumber;
	int lineNumber;
};
#endif
