#include "BlockExportColumn.h"

BlockExportColumn::BlockExportColumn(QString caption) : ExportColumn(caption) {
}

void BlockExportColumn::setExportBlock(ExportBlock *block) {
	this->block = block;
	this->block->setParent(this);
}

ExportBlock *BlockExportColumn::getExportBlock() {
	return this->block;
}

int BlockExportColumn::setCaptionCoordinates(DatabaseContext *context, int row, int column) {
	setCaptionRow(row);
	setCaptionStartColumn(column);

	int childColumns = getExportBlock()->setCaptionCoordinates(context, row + 1, column);
	int parentColumns = captions.size();
	return (childColumns > parentColumns ? childColumns : parentColumns);
}

void BlockExportColumn::calculateCaptions(DatabaseContext *context, CSVFileData *csvFileData) {
	for (int n = captionStartColumn; n < captionStartColumn + captions.size(); n++) {
		csvFileData->setValue(captionRow, n, captions[n - captionStartColumn]);
	}

	block->calculateCaptions(context, csvFileData);
}

void BlockExportColumn::processConverters(DatabaseContext *context) {
}

void BlockExportColumn::calculateContents(DatabaseContext *context, CSVFileData *csvFileData, int startRow) {
	block->calculateContents(context, csvFileData, startRow);
}

int BlockExportColumn::getMaxCaptionRow() {
	int childMaxCaptionRow = block->getMaxCaptionRow();
	return (captionRow > childMaxCaptionRow ? captionRow : childMaxCaptionRow);
}

int BlockExportColumn::getMaxDataRow() {
	return block->getMaxDataRow();
}
