#ifndef BLOCKEXPORTCOLUMN_H
#define BLOCKEXPORTCOLUMN_H

#include <QString>

#include <map>

#include "ExportBlock.h"
#include "ExportColumn.h"

class BlockExportColumn : public ExportColumn {

public:
	BlockExportColumn(QString caption);

	void setExportBlock(ExportBlock *block);
	ExportBlock *getExportBlock();

	virtual int setCaptionCoordinates(DatabaseContext *context, int row, int column);
	virtual void calculateCaptions(DatabaseContext *context, CSVFileData *csvFileData);
	virtual void calculateContents(DatabaseContext *context, CSVFileData *csvFileData, int startRow);
	virtual void processConverters(DatabaseContext *context);

	virtual int getMaxCaptionRow();
	virtual int getMaxDataRow();

private:
	ExportBlock *block;

};
#endif
