#ifndef DATAEXPORTCOLUMN_H
#define DATAEXPORTCOLUMN_H

#include <QString>

#include <map>

#include "ExportColumn.h"
#include "ExportPath.h"

class DataExportColumn : public ExportColumn {

public:
	DataExportColumn(QString caption, ExportPath* path);

	void setValue(int row, QString data);
	bool hasValue(int row);
	int getFirstIndexOfValue(QString data);
	std::vector<QString> getData();

	virtual int setCaptionCoordinates(DatabaseContext *context, int row, int column);
	virtual void calculateCaptions(DatabaseContext *context, CSVFileData *csvFileData);
	virtual void calculateContents(DatabaseContext *context, CSVFileData *csvFileData, int startRow);
	virtual void processConverters(DatabaseContext *context);

	virtual int getMaxCaptionRow();
	virtual int getMaxDataRow();

private:
	std::map<int, QString> rowToData;
	ExportPath* path;
};
#endif
