#ifndef EXPORTBLOCK_H
#define EXPORTBLOCK_H

#include "ExportColumn.h"

#include <QString>

#include <map>

class BlockExportColumn;

#include "CSVFileData.h"
#include "CSVFormat.h"
#include "DatabaseContext.h"
#include "ExportParameters.h"

class ExportBlock {

public:
	ExportBlock();

	void addColumn(QString key, ExportColumn *column);
	ExportColumn *getColumn(QString key);
	bool hasColumn(QString key);
	std::vector<ExportColumn*> getAllColumns();
	BlockExportColumn *getParent();
	void setParent(BlockExportColumn *parent);
	ExportBlock *getSuperParent();

	void exchangeColumn(QString key, ExportColumn *newColumn);

	virtual int getMaxCaptionRow();
	virtual int getMaxDataRow();

	virtual int setCaptionCoordinates(DatabaseContext *context, int row, int column);
	virtual void calculateCaptions(DatabaseContext *context, CSVFileData *csvFileData);
	virtual void calculateContents(DatabaseContext *context, CSVFileData *csvFileData, int startRow);
	virtual void processConverters(DatabaseContext *context);

private:
	std::vector<ExportColumn*> columns;
	std::map<QString, ExportColumn*> columnKeyToColumn;

	BlockExportColumn *parent;
};
#endif
