#ifndef EXPORTCOLUMN_H
#define EXPORTCOLUMN_H

class ExportBlock;

#include <QString>

#include "CSVFileData.h"
#include "CSVFormat.h"
#include "DatabaseContext.h"

#include <vector>

class ExportColumn {

public:
	ExportColumn(QString caption);

	void setKey(QString key);
	QString getKey();

	void setCaptionRow(int captionRow);
	int getCaptionRow();

	void setCaptionStartColumn(int captionStartColumn);
	int getCaptionStartColumn();

	int getCaptionWidth();

	void setParent(ExportBlock *exportBlock);
	ExportBlock *getParent();
	ExportBlock *getSuperParent();

	virtual int setCaptionCoordinates(DatabaseContext *context, int row, int column) = 0;
	virtual void calculateCaptions(DatabaseContext *context, CSVFileData *csvFileData) = 0;
	virtual void calculateContents(DatabaseContext *context, CSVFileData *csvFileData, int startRow) = 0;
	virtual void processConverters(DatabaseContext *context) = 0;

	virtual int getMaxCaptionRow() = 0;
	virtual int getMaxDataRow() = 0;

protected:
	QString key;
	std::vector<QString> captions;
	int captionRow;
	int captionStartColumn;
	ExportBlock *parent;
};
#endif
