#ifndef EXPORTPARAMETERS_H
#define EXPORTPARAMETERS_H

#include "ExportPath.h"

#include <QString>
#include <QStringList>

#include <map>
#include <vector>

class ExportParameters {

public:
	ExportParameters(bool exportLineSpecifiers, bool exportEntityNames, bool exportMetaInformation, bool exportSchema, std::map<QString, std::vector<ExportPath*> > exportPaths);

	bool doExportLineSpecifiers();
	bool doExportEntityNames();
	bool doExportMetaInformation();
	bool doExportSchema();

	std::map<QString, std::vector<ExportPath*> > getExportPaths();

private:
	bool exportLineSpecifiers;
	bool exportEntityNames;
	bool exportMetaInformation;
	bool exportSchema;

	std::map<QString, std::vector<ExportPath*> > exportPaths;
};
#endif
