#include "ExportPath.h"

#include "ExportConverter.h"

ExportPath::ExportPath(QStringList path) {
	this->path = path;
	this->caption = QString();
	this->converter = NULL;
}

ExportPath::ExportPath(QStringList path, QString caption) {
	this->path = path;
	this->caption = caption;
	this->converter = NULL;
}

ExportPath::ExportPath(QStringList path, QString caption, ExportConverter *converter) {
	this->path = path;
	this->caption = caption;
	this->converter = converter;
}

QStringList ExportPath::getPath() {
	return this->path;
}

QString ExportPath::getPathString() {
	QString pathString = "";
	for (int n = 0; n < path.size(); n++) {
		pathString += path.at(n) + (n < path.size() - 1 ? "." : "");
	}
	return pathString;
}

QString ExportPath::getCaption() {
	return this->caption;
}

ExportConverter* ExportPath::getConverter() {
	return this->converter;
}
