#include "WettbewerbAlleineExportCallStrategy.h"

#include "CSVDataExporter.h"
#include "DataExporter.h"
#include "DataSet.h"
#include "ExportHelper.h"

#include <vector>

#include "Persistent.h"

WettbewerbAlleineExportCallStrategy::WettbewerbAlleineExportCallStrategy(Wettbewerb *wettbewerb) {
	this->wettbewerb = wettbewerb;
}

void WettbewerbAlleineExportCallStrategy::exportData(DatabaseContext *context, QString fileName) {

	std::vector<Persistent*> persistents = ExportHelper::getPersistentsZuWettbewerb(context, wettbewerb);

	// construct Exporter and DataSet
	DataExporter *exporter = new CSVDataExporter();
	DataSet *dataSet = exporter->constructDataSetForExport();
	exporter->addToDataSetForExport(context, dataSet, persistents);

	// export
	exporter->exportData(context, fileName, dataSet);

	delete exporter;
	delete dataSet;
}


