#include "ConstantValueFillConverter.h"

#include "ExportBlock.h"

ConstantValueFillConverter::ConstantValueFillConverter(QString fillValue) {
	this->fillValue = fillValue;
}


void ConstantValueFillConverter::convert(DatabaseContext *context, DataExportColumn *exportColumn) {
	ExportBlock *superParent = exportColumn->getSuperParent();
	int maxDataRow = (superParent != NULL ? superParent->getMaxDataRow() : -1);
	for (int n = 0; n <= maxDataRow; n++) {
		exportColumn->setValue(n, fillValue);
	}
}

std::vector<QVariant> ConstantValueFillConverter::convertData(DatabaseContext *context, QVariant data) {
	return std::vector<QVariant>();
}


