#include "RangConverter.h"

#include <QObject>


#include "BlockExportColumn.h"
#include "DataExportColumn.h"
#include "Durchgang.h"
#include "EinzelWertungsListeJoinController.h"
#include "WertungsHelper.h"

#include "EinzelwertungenExterneJurorenJoinController.h"
#include "EinzelwertungenMitgliederJoinController.h"
#include "EinzelwertungsAnzeigeJoinModel.h"
#include "EinzelwertungsAnzeigeJoinSearchModel.h"

RangConverter::RangConverter(std::vector<EinzelWertungsListeJoinModel*> joinModels) {
	this->joinModels = joinModels;
}

void RangConverter::convert(DatabaseContext *context, DataExportColumn *exportColumn) {
	context->log("ImportExport", "RangWertungConverter", 6, "RangWertungConverter gestartet.");

	std::vector<QString> oldData = exportColumn->getData();
	std::set<qlonglong> alreadyProcessedWTIds = std::set<qlonglong>();
	int rang = 1;
	for (int n = 0; n < oldData.size(); n++) {
		QString wtIdString = oldData[n];
		qlonglong wtId = wtIdString.toLongLong();
		if (alreadyProcessedWTIds.find(wtId) == alreadyProcessedWTIds.end()) {
			alreadyProcessedWTIds.insert(wtId);

			exportColumn->setValue(n, QString::number(rang));
			rang++;
		} else {
			exportColumn->setValue(n, "");
		}
	}

	context->log("ImportExport", "RangWertungConverter", 6, "RangWertungConverter fertig.");
}

std::vector<QVariant> RangConverter::convertData(DatabaseContext *context, QVariant data) {
/*
	EinzelwertungenExterneJurorenJoinController externeJurorenController = EinzelwertungenExterneJurorenJoinController();
	EinzelwertungenMitgliederJoinController mitgliederController = EinzelwertungenMitgliederJoinController();
	EinzelwertungsAnzeigeJoinSearchModel *searchModel = new EinzelwertungsAnzeigeJoinSearchModel();
	searchModel->setEinzelWertungWertung(data.toLongLong());

	std::vector<EinzelwertungsAnzeigeJoinModel*> einzelWertungen = externeJurorenController.get(context, searchModel);

	std::vector<EinzelwertungsAnzeigeJoinModel*> einzelWertungenMitglieder = mitgliederController.get(context, searchModel);
	for (std::vector<EinzelwertungsAnzeigeJoinModel*>::const_iterator it = einzelWertungenMitglieder.begin(); it != einzelWertungenMitglieder.end(); it++) {
		einzelWertungen.push_back(*it);
	}
	delete searchModel;

	std::vector<QVariant> retData = std::vector<QVariant>();

	for (std::vector<EinzelwertungsAnzeigeJoinModel*>::const_iterator it = einzelWertungen.begin(); it != einzelWertungen.end(); it++) {
		EinzelwertungsAnzeigeJoinModel *einzelWertung = *it;

		QString vorname = (einzelWertung->hasPersonVorname() ? einzelWertung->getPersonVorname() : "ohne Vorname");
		QString nachname = (einzelWertung->hasPersonNachname() ? einzelWertung->getPersonNachname() : "ohne Nachname");
		QString bewertung = (einzelWertung->hasEinzelWertungBewertung() ? QString::number(einzelWertung->getEinzelWertungBewertung()) : "ohne Bewertung");

		retData.push_back(QVariant(vorname));
		retData.push_back(QVariant(nachname));
		retData.push_back(QVariant(bewertung));
	}

	return retData;*/
	return std::vector<QVariant>();
}


