#ifndef EXTRACTTHREAD_H
#define EXTRACTTHREAD_H

#include <map>
#include <vector>

#include <QDir>
#include <QObject>
#include <QString>
#include <QThread>

#include "DatabaseContext.h"
#include "Exception.h"
#include "Session.h"

class ExtractThread : public QThread {

	Q_OBJECT

public:
	ExtractThread(DatabaseContext *context, QString fileName);

signals:
	void statusMessage(QString status);
	void extractionFailed(QString shortText, QString longText);
	void extractionFinished(bool createdTempDir, QString tempDir, QString importFileName);

protected:
	void run();

private:
	DatabaseContext *context;
	DatenbankVerbindung *datenbankVerbindung;
	Session *session;
	QString fileName;
};
#endif
