#include "ForeignKeyDestination.h"

ForeignKeyDestination::ForeignKeyDestination() {
	this->fkIsNull = true;
	this->keyInDatabase = QVariant();
	this->loadedTuple = NULL;
}

ForeignKeyDestination::ForeignKeyDestination(QVariant keyInDatabase) {
	this->fkIsNull = false;
	this->keyInDatabase = keyInDatabase;
	this->loadedTuple = NULL;
}

ForeignKeyDestination::ForeignKeyDestination(DataTuple *loadedTuple) {
	this->fkIsNull = false;
	this->keyInDatabase = QVariant();
	this->loadedTuple = loadedTuple;
}

bool ForeignKeyDestination::isNull() {
	return fkIsNull;
}

bool ForeignKeyDestination::pointsToDatabase() {
	return keyInDatabase.isValid();
}

QVariant ForeignKeyDestination::getKeyInDatabase() {
	return keyInDatabase;
}

void ForeignKeyDestination::setKeyInDatabase(QVariant keyInDatabase) {
	this->keyInDatabase = keyInDatabase;
	this->fkIsNull = false;
}

bool ForeignKeyDestination::pointsToTuple() {
	return (loadedTuple != NULL);
}

void ForeignKeyDestination::setLoadedTuple(DataTuple *loadedTuple) {
	this->loadedTuple = loadedTuple;
	this->fkIsNull = false;
}

DataTuple *ForeignKeyDestination::getLoadedTuple() {
	return loadedTuple;
}
