#include "ImportResult.h"

ImportResult::ImportResult() {
	exceptions = std::vector<Exception>();
	entityDBNameToNumber = std::map<QString, int>();
	numberOfInstances = 0;
}

void ImportResult::addException(Exception e) {
	exceptions.push_back(e);
}

bool ImportResult::hasExceptions() {
	return exceptions.size() > 0;
}

void ImportResult::instanceImported(QString entityDBName) {
	if (entityDBNameToNumber.find(entityDBName) != entityDBNameToNumber.end()) {
		entityDBNameToNumber[entityDBName] = entityDBNameToNumber[entityDBName] + 1;
	} else {
		entityDBNameToNumber[entityDBName] = 1;
	}
	numberOfInstances++;
}

int ImportResult::getNumberOfInstances() {
	return numberOfInstances;
}

std::map<QString, int> ImportResult::getEntityDBNameToNumberMap() {
	return entityDBNameToNumber;
}

const std::vector<Exception> ImportResult::getAllExceptions() {
	return exceptions;
}

void ImportResult::setStartDateTime(QDateTime startDateTime) {
	this->startDateTime = startDateTime;
}

QDateTime ImportResult::getStartDateTime() {
	return startDateTime;
}
