#ifndef IMPORTRESULT_H
#define IMPORTRESULT_H

#include <map>
#include <vector>

#include <QDateTime>
#include <QString>

#include "Exception.h"

class ImportResult {

public:
	ImportResult();

	void addException(Exception e);
	bool hasExceptions();
	const std::vector<Exception> getAllExceptions();

	void instanceImported(QString entityDBName);

	int getNumberOfInstances();
	std::map<QString, int> getEntityDBNameToNumberMap();

	void setStartDateTime(QDateTime startDateTime);
	QDateTime getStartDateTime();
private:
	std::vector<Exception> exceptions;

	int numberOfInstances;
	QDateTime startDateTime;
	std::map<QString, int> entityDBNameToNumber;
};
#endif
