#ifndef IMPORTTHREAD_H
#define IMPORTTHREAD_H

#include <map>
#include <vector>

#include <QDir>
#include <QObject>
#include <QString>
#include <QThread>

#include "DatabaseContext.h"
#include "DatenbankVerbindung.h"
#include "Exception.h"
#include "ImportResult.h"
#include "Session.h"

class ImportThread : public QThread {

	Q_OBJECT

public:
	ImportThread(DatabaseContext *context, bool createdTempDir, QString tempDir, QString fileName);

signals:
	void statusMessage(QString status);
	void importFailed(QString shortMessage, QString longMessage);
	void importFinished(DatabaseContext *context, ImportResult *importResult, bool createdTempDir, QString tempDir);

protected:
	void run();

private slots:
	void statusMessageFromImporter(QString statusMessage);

private:
	DatenbankVerbindung *datenbankVerbindung;
	Session *session;
	DatabaseContext *context;
	bool createdTempDir;
	QString tempDir;
	QString fileName;
};
#endif
