#include "BildImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void BildImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "Bild") {
		throw ImportException("ImportExport", "BildImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("BildImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerbsTeilnahme");
		testForMustFK(dataTuple, "sparte");
		testForMustFK(dataTuple, "bildDaten");

		testForMustValue(dataTuple, "anzahlRotierSchritte");

		if (!dataTuple->hasAttributeData("gueltig")) {
			// Beim Importieren Bilder im Zweifelsfall gueltig machen.  Ungueltige Bilder kann es nur beim Hochladen über die Webschnittstelle
			// geben falls der Benutzer zu früh abbricht
			QVariant trueVariant = QVariant(true);
			dataTuple->setValue("gueltig", trueVariant);
		}
	}
}
