#include "CodeValueImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void CodeValueImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "CodeValue") {
		throw ImportException("ImportExport", "CodeValueImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("CodeValueImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "type");
		testForMustValue(dataTuple, "name");
		testForMustValue(dataTuple, "kurzText");
		testForMustValue(dataTuple, "globalText");
		testForMustValue(dataTuple, "reihenfolge");
	}
}
