#include "DurchgangImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void DurchgangImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "Durchgang") {
		throw ImportException("ImportExport", "DurchgangImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("DurchgangImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "jurierung");
		testForMustFK(dataTuple, "sparte");
		testForMustFK(dataTuple, "jugend");
		testForMustFK(dataTuple, "art");
		testForMustFK(dataTuple, "sortierModus");
		testForMustFK(dataTuple, "status");

		testForMustValue(dataTuple, "minBewertung");
		testForMustValue(dataTuple, "maxBewertung");
	}
}
