#include "EventLogImportStrategy.h"

#include "AttributeData.h"
#include "DataImporter.h"
#include "ImportException.h"
#include "QtToSQLConverter.h"

#include <QDateTime>

void EventLogImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
														  ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "EventLog") {
		throw ImportException("ImportExport", "EventLogImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("EventLogImportStrategy falsch aufgerufen"));
	} else {
		dataTuple->setValue("import_tist", QVariant(QDateTime::currentDateTime().toString(Qt::ISODate)));
	}
}

bool EventLogImportStrategy::insertAlways(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
										  ImportResult *importResult) {
	return true;
}
