#include "FotographischerTitelImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void FotographischerTitelImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "FotographischerTitel") {
		throw ImportException("ImportExport", "FotographischerTitelImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("FotographischerTitelImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "mitglied");
		testForMustValue(dataTuple, "titel");
		testForMustFK(dataTuple, "art");
	}
}
