#include "JuriertBeiImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void JuriertBeiImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "JuriertBei") {
		throw ImportException("ImportExport", "JuriertBeiImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("JuriertBeiImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerb");
		testForMustFK(dataTuple, "art");

		if (dataTuple->hasAttributeData("art.name")) {
			AttributeData *artAD = dataTuple->getAttributeData("art.name");
			if (artAD->isValue()) {
				QString art = artAD->getValue().toString();
				if (art == "EXTERNER_JUROR") {
					testForMustFK(dataTuple, "externerJuror");
				} else if (art == "MITGLIED") {
					testForMustFK(dataTuple, "mitglied");
				}
			}
		}
	}
}
