#include "JurierungImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void JurierungImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "Jurierung") {
		throw ImportException("ImportExport", "JurierungImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("JurierungImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerb");
		testForMustFK(dataTuple, "jurierungsModus");
		testForMustFK(dataTuple, "anzahlDurchgaenge");
	}
}
