#include "QueryLogImportStrategy.h"

#include "AttributeData.h"
#include "DataImporter.h"
#include "GlobaleWidgetEigenschaften.h"
#include "ImportException.h"
#include "QtToSQLConverter.h"

#include <QDateTime>

void QueryLogImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
														  ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "QueryLog") {
		throw ImportException("ImportExport", "QueryLogImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("QueryLogImportStrategy falsch aufgerufen"));
	} else {
		dataTuple->setValue("import_tist", QVariant(QDateTime::currentDateTime().toString(GlobaleWidgetEigenschaften::getDateTimeFormat())));
	}
}

bool QueryLogImportStrategy::insertAlways(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
										  ImportResult *importResult) {
	return true;
}
