#include "SessionImportStrategy.h"

#include "AttributeData.h"
#include "DataImporter.h"
#include "ImportException.h"
#include "QtToSQLConverter.h"

#include <QDateTime>

void SessionImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
														  ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "Session") {
		throw ImportException("ImportExport", "SessionImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("SessionImportStrategy falsch aufgerufen"));
	} else {
		dataTuple->setValue("import_tist", QVariant(QDateTime::currentDateTime().toString(Qt::ISODate)));
	}
}

bool SessionImportStrategy::insertAlways(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple,
										 ImportResult *importResult) {
	return false;
}
