#include "TeilnehmerKombinationsWertungImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void TeilnehmerKombinationsWertungImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "TeilnehmerKombinationsWertung") {
		throw ImportException("ImportExport", "TeilnehmerKombinationsWertungImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("TeilnehmerKombinationsWertungImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerb");
		testForMustFK(dataTuple, "wettbewerbsTeilnahme");
		testForMustFK(dataTuple, "jugend");
		testForMustFK(dataTuple, "verein");
	}
}
