#include "TeilnehmerWertungImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void TeilnehmerWertungImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "TeilnehmerWertung") {
		throw ImportException("ImportExport", "TeilnehmerWertungImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("TeilnehmerWertungImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerb");
		testForMustFK(dataTuple, "wettbewerbsTeilnahme");
		testForMustFK(dataTuple, "jugend");
		testForMustFK(dataTuple, "sparte");
		testForMustFK(dataTuple, "verein");
	}
}
