#include "VereinsDatenBerechtigungImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void VereinsDatenBerechtigungImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "VereinsDatenBerechtigung") {
		throw ImportException("ImportExport", "VereinsDatenBerechtigungImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("VereinsDatenBerechtigungImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "benutzer");
		testForMustFK(dataTuple, "verein");
		testForMustFK(dataTuple, "ausdehnung");
		testForMustFK(dataTuple, "art");
		testForMustFK(dataTuple, "objektTyp");
	}
}
