#include "VereinsWertungImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void VereinsWertungImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "VereinsWertung") {
		throw ImportException("ImportExport", "VereinsWertungImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("VereinsWertungImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "wettbewerb");
		testForMustFK(dataTuple, "jugend");
		testForMustFK(dataTuple, "verein");
		testForMustFK(dataTuple, "sparte");
	}
}
