#include "WettbewerbImportStrategy.h"

#include <QString>

#include "AttributeData.h"
#include "ImportException.h"

void WettbewerbImportStrategy::checkAndConvertBeforeResolve(DatabaseContext *context, DataSet *dataSet, DataTuple *dataTuple, ImportResult *importResult) {
	if (dataTuple->getEntityDBName() != "Wettbewerb") {
		throw ImportException("ImportExport", "WettbewerbImportStrategy", trUtf8("Technischer Fehler"),
							trUtf8("WettbewerbImportStrategy falsch aufgerufen"));
	} else {
		testForMustFK(dataTuple, "verein");
		testForMustFK(dataTuple, "status");

		testForMustValue(dataTuple, "name");
		testForMustValue(dataTuple, "nummer");
		testForMustValue(dataTuple, "anzahlBilderFuerWertung");
		testForMustValue(dataTuple, "anzahlSpartenFuerKombination");
		testForMustValue(dataTuple, "anzahlTeilnehmerFuerVereinsW");
	}
}
