#ifndef WERTUNGSHELPER_H
#define WERTUNGSHELPER_H

#include "Bild.h"
#include "BilderNachWettbewerbJoinModel.h"
#include "DatabaseContext.h"
#include "Durchgang.h"
#include "EinzelwertungsAnzeigeJoinModel.h"
#include "JuriertBeiPersonJoinModel.h"
#include "Sparte.h"
#include "Wertung.h"
#include "WettbewerbCache.h"

#include <vector>

class WertungsHelper {

public:
	static bool istErsterDurchgang(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istZweiterDurchgang(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istJugendDurchgang(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istErwachsenenDurchgang(DatabaseContext *databaseContext, Durchgang *durchgang);

	static Durchgang* getErsterDurchgang(DatabaseContext *context, Sparte *sparte, bool jugend);

	static bool kannWertungStarten(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istAbgeschlosseneWertung(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istNeueWertung(DatabaseContext *databaseContext, Durchgang *durchgang);
	static bool istHoechsterDurchgang(DatabaseContext *databaseContext, Durchgang *durchgang);

	static bool istBasisDurchgangAbgeschlossen(DatabaseContext *databaseContext, Durchgang *durchgang);

	static void setzeWertungenZurueck(DatabaseContext *databaseContext, Durchgang *durchgang);
	static void setzeDurchgangAufGestartet(DatabaseContext *databaseContext, Durchgang *durchgang);
	static void setzeDurchgangAufAbgeschlossen(DatabaseContext *databaseContext, Durchgang *durchgang);

	static void loescheWertungen(DatabaseContext *context, Durchgang *durchgang);

	static bool filtereNachJugend(DatabaseContext *context, Wettbewerb *wettbewerb, Sparte *sparte, Durchgang *durchgang, BilderNachWettbewerbJoinModel *joinModel);
	static void generiereWertungen(DatabaseContext *databaseContext, Wettbewerb *wettbewerb, Durchgang *durchgang);
	static void beginneWertung(DatabaseContext *databaseContext, Wettbewerb *wettbewerb,
							   Durchgang *durchgang);
	static void ladeWertungen(DatabaseContext *databaseContext, WettbewerbCache *wettbewerbCache,
							Durchgang *durchgang);

	static std::vector<Wertung*> filterWertungen(DatabaseContext *databaseContext, std::vector<Wertung*> wertungen,
												 Durchgang *durchgang);


	static bool setzeNaechsteOffeneWertung(DatabaseContext *databaseContext, WettbewerbCache *wettbewerbCache,
										   Durchgang *durchgang);
	static std::vector<JuriertBeiPersonJoinModel*> ladeJuroren(DatabaseContext *databaseContext, Wettbewerb *wettbewerb, Sparte *sparte);
	static std::vector<EinzelwertungsAnzeigeJoinModel*> ladeEinzelwertungen(DatabaseContext *databaseContext,
		Wertung *wertung);
	static void legeEinzelwertungenAn(DatabaseContext *databaseContext, Wertung *wertung, Wettbewerb *wettbewerb, Sparte *sparte);

	static bool istWertungKomplett(std::vector<EinzelwertungsAnzeigeJoinModel*> einzelwertungen);
	static void aktualisiereGesamtwertung(DatabaseContext *databaseContext, Wertung *wertung, Bild *bild,
										  std::vector<EinzelwertungsAnzeigeJoinModel*> einzelwertungen);

	static int getRandomNumber(int maxValue);
private:


};
#endif
