#ifndef KEYBOARDMANAGER_H
#define KEYBOARDMANAGER_H

#include <QObject>

class KeyboardManager : public QObject {

	Q_OBJECT;
public:
	/** Registers for listening to all attached keyboards, including numeric keyboards.
	 *  After this function was called, the signals defined by this class are
	 *  guaranteed to be emitted once the corresponding event happens.
	 */
	virtual void registerKeyboards() = 0;

	/** Prints some information about the attached devices to standard output.
	 *
	 */
	virtual void printDeviceInformation() = 0;

signals:
	void numericKeyPressed(qlonglong device, int number);

};
#endif
