#include "BotanRSAManager.h"

#include <QString>

#include "PrivateRSAKey.h"
#include "PublicRSAKey.h"

#include <botan/botan.h>
#include <botan/rsa.h>

RSAKeyPair* BotanRSAManager::generateKeyPair() {
	Botan::LibraryInitializer init;

	Botan::AutoSeeded_RNG rng;
	Botan::RSA_PrivateKey privateKeyBotan(rng, 1024);
	std::string pemEncodedPrivateKeyStdString = Botan::PKCS8::PEM_encode(privateKeyBotan);
	QString pemEncodedPrivateKeyQString = QString::fromStdString(pemEncodedPrivateKeyStdString);
	PrivateRSAKey *privateRSAKey = new PrivateRSAKey(pemEncodedPrivateKeyQString);

	std::string pemEncodedPublicKeyStdString = Botan::X509::PEM_encode(privateKeyBotan);
	QString pemEncodedPublicKeyQString = QString::fromStdString(pemEncodedPublicKeyStdString);
	PublicRSAKey *publicRSAKey = new PublicRSAKey(pemEncodedPublicKeyQString);

	return new RSAKeyPair(privateRSAKey, publicRSAKey);
}

PrivateRSAKey* BotanRSAManager::loadPrivateKey(QString representation) {
	return NULL;
}

PublicRSAKey* BotanRSAManager::loadPublicKey(QString representation) {
	return NULL;
}

QString BotanRSAManager::encryptToHex(PrivateRSAKey *privateKey, QString data) {
	return QString();
}

QString BotanRSAManager::decryptFromHex(PublicRSAKey *publicKey, QString data) {
	return QString();
}
