#ifndef DUMMYRSAMANAGER_H
#define DUMMYRSAMANAGER_H

#include <QString>

#include "PrivateRSAKey.h"
#include "PublicRSAKey.h"
#include "RSAKeyPair.h"
#include "RSAManager.h"

class DummyRSAManager : public RSAManager {

public:
	virtual RSAKeyPair* generateKeyPair();
	virtual PrivateRSAKey* loadPrivateKey(QString representation);
	virtual PublicRSAKey* loadPublicKey(QString representation);
	virtual QString encryptToHex(PrivateRSAKey *privateKey, QString data);
	virtual QString decryptFromHex(PublicRSAKey *publicKey, QString data);

private:
	void initRandomGenerator();
	int stringToInt(QString s);
	QString intToString(int i);

	int getKeyGap(int n);
};
#endif
