#ifndef LICENSEMANAGER_H
#define LICENSEMANAGER_H

#include <QString>

#include "DatabaseContext.h"
#include "LicenseKey.h"

class LicenseManager {

public:
	static QString getHardwareKey(DatabaseContext *databaseContext);
	static LicenseKey* loadLicenseKey(DatabaseContext *context);

	/** Extracts the expire date from the given license key.  An invalid return
	 *  value indicates that the license key could not be properly read and/or
	 *  extracted.  In case of an unlimited license, the 31st December 2999 is
	 *  returned.
	 *  @return expire date as described
	 */
	static QDate getExpireDate(LicenseKey *licenseKey);

    static QDate getExpireWettbewerbDate(LicenseKey *key);

	static void checkLicenseKey(DatabaseContext *context, LicenseKey *key);

	static void checkLicenseKey(DatabaseContext *context);

private:
	static std::vector<QString> getDeviceNameOrder();
};
#endif
