// The purpose of this class is just saving the QCA related code implemented.
// As I was not able to make QCA work for me properly, this code is not
// meant to be compiled or used without improving / fixing it before.

#include "QCARSAManager.h"

RSAKeyPair* QCARSAManager::generateKeyPair() {
    if(!QCA::isSupported("pkey") ||
       !QCA::PKey::supportedIOTypes().contains(QCA::PKey::RSA)) {

		QMessageBox::critical(this, trUtf8("Algorithmus nicht unterstuetzt"), trUtf8("Leider wird der RSA-Algorithmus aus unbekannten Gruenden nicht unterstuetzt"), QMessageBox::Ok);
		keysGenerated = false;
		return;
	} else {
		// In terms of RSA, the private key, but in terms of this application the public key
		publicKey = QCA::KeyGenerator().createRSA(1024);
		if(publicKey.isNull()) {
			QMessageBox::critical(this, trUtf8("Schluesselerzeugung fehlgeschlagen"), trUtf8("Die Erzeugung des privaten Schluessels ist fehlgeschlagen."), QMessageBox::Ok);
			return;
		}
		// In terms of RSA, the public key, but in terms of this application the private key
		privateKey = publicKey.toPublicKey();

		publicKeyString = publicKey.toPEM();
		privateKeyString = privateKey.toPEM();
	}
	return NULL;
}

PrivateRSAKey* QCARSAManager::loadPrivateKey(QString representation) {
		QCA::ConvertResult conversionResult;
		QCA::PublicKey privateKey = QCA::PublicKey::fromPEM(privateKeyString, &conversionResult);
		if (! (QCA::ConvertGood == conversionResult) ) {
			QMessageBox::critical(this, trUtf8("Schluessel konnte nicht geladen werden"), trUtf8("Beim Laden des privaten Schluessels ist ein Fehler aufgetreten.  Er konnte leider "
																								"nicht geladen werden."));
			return;
		}
}

	// convert again, since QCA::Initializer has to be within scope - using the privateKey instance generated when loading the key from file results in a segfault
	QCA::ConvertResult conversionResult;
	QCA::PublicKey privateKey = QCA::PublicKey::fromPEM(privateKeyString, &conversionResult);
	if (! (QCA::ConvertGood == conversionResult) ) {
		QMessageBox::critical(this, trUtf8("Schluessel konnte nicht geladen werden"), trUtf8("Bei der Verarbeitung des des privaten Schluessels ist ein Fehler aufgetreten."));
		return;
	}
	if (!privateKey.canEncrypt()) {
		QMessageBox::critical(this, trUtf8("Schluessel kann nicht verschluesseln"), trUtf8("Aus unbekannten Gruenden ist keine Verschluesselung moeglich."));
		return;
	}

PublicRSAKey* QCARSAManager::loadPublicKey(QString representation) {
	QCA::ConvertResult conversionResult;
	QCA::PrivateKey publicKey = QCA::PrivateKey::fromPEM(publicKeyString, QCA::SecureArray(), &conversionResult);
	if (! (QCA::ConvertGood == conversionResult) ) {
		QMessageBox::critical(this, trUtf8("Schluessel konnte nicht geladen werden"), trUtf8("Beim Laden des oeffentlichen Schluessels ist ein Fehler aufgetreten.  Er konnte leider "
																							"nicht geladen werden."));
		return;
	}
}



QString QCARSAManager::encryptToHex(PrivateRSAKey *privateKey, QString data) {
	QCA::SecureArray unencryptedDataArray = unencryptedData.toAscii();
	QCA::SecureArray originalData = QCA::SecureArray(unencryptedDataArray);

	QCA::SecureArray encryptedData = privateKey.encrypt(originalData, QCA::EME_PKCS1_OAEP);
	if(encryptedData.isEmpty()) {
		QMessageBox::critical(this, trUtf8("Lizenz konnte nicht erzeugt werden"), trUtf8("Bei der Verschluesselung der Lizenz ist ein Fehler aufgetreten."));
		return;
	}

	QByteArray encryptedDataByteArray = encryptedData.toByteArray();
	licenseKeyString = DataHelper::toHexRepresentation(encryptedDataByteArray);
}

QString QCARSAManager::decryptFromHex(PublicRSAKey *publicKey, QString data) {
	QByteArray readDataAsByteArray = DataHelper::fromHexRepresentation(hexDataRead);
	QCA::SecureArray readDataArray = QCA::SecureArray(readDataAsByteArray);
	QCA::SecureArray decrypt;
	if(0 == publicKey.decrypt(readDataArray, &decrypt, QCA::EME_PKCS1_OAEP)) {
		if (fromFile) {
			QMessageBox::critical(this, trUtf8("Lizensierungsschluessel fehlerhaft"), trUtf8("Bitte ueberpruefen Sie ihren Lizensierungsschluessel, oder kontaktieren Sie "
												"den Administrator."));
		}
		return;
	}
}
