#ifndef RSAMANAGER_H
#define RSAMANAGER_H

#include <QString>

#include "RSAKeyPair.h"
#include "PublicRSAKey.h"
#include "PrivateRSAKey.h"

class RSAManager {

public:
	virtual RSAKeyPair* generateKeyPair() = 0;
	virtual PrivateRSAKey* loadPrivateKey(QString representation) = 0;
	virtual PublicRSAKey* loadPublicKey(QString representation) = 0;
	virtual QString encryptToHex(PrivateRSAKey *privateKey, QString data) = 0;
	virtual QString decryptFromHex(PublicRSAKey *publicKey, QString data) = 0;
};
#endif
