#ifndef EVENTLOGGER_H
#define EVENTLOGGER_H

#include <QString>

#include <map>
#include <vector>

#include "EventLogCategory.h"
#include "EventLogSettings.h"

class DatabaseContext;

class EventLogger {

public:
	EventLogger(DatabaseContext *context);
	~EventLogger();

	void disable();
	void reloadConfig(DatabaseContext *context);

	void log(QString categoryName, QString location, int level, QString text);

private:
	DatabaseContext *context;

	std::map<QString, EventLogCategory*> categoryNameToCategory;
	std::map<qlonglong, EventLogSettings*> settingsIdToSettings;
	std::multimap<qlonglong, EventLogSettings*> categoryIdToSettings;
	std::multimap<QString, EventLogSettings*> locationToSettings;
	std::vector<EventLogSettings*> withoutCategoryAndLocation;

	void deleteConfigObjects();
	bool output(EventLogSettings* settings, EventLogCategory *category, QString location, int level);
	bool outputToDB(EventLogSettings* settings);
	bool outputToStdOut(EventLogSettings *settings);

	bool enabled;
};
#endif
